using System;
public class runme
{
    static public void Main()
    {
        //create points with the swig doubleArray proxy
        //http://www.swig.org/Doc3.0/SWIGDocumentation.html#Library_carrays
        doubleArray p = new doubleArray(12); //column major
        p.setitem(0, 0.0); p.setitem(3, 0.5); p.setitem(6, 0.5); p.setitem(9, 0.0);
        p.setitem(1, 0.0); p.setitem(4, 0.0); p.setitem(7, 1.0); p.setitem(10, 1.0);
        p.setitem(2, 0.0); p.setitem(5, 1.0); p.setitem(8, 0.0); p.setitem(11, 1.0);
        System.Console.WriteLine("Input points:");
        printArray(p ,4);
        SWIGTYPE_p_ShapeOpSolver s = shapeopCSharp.shapeop_create();
        shapeopCSharp.shapeop_setPoints(s, p.cast(), 4);
        double weight = 1.0;
        //add a plane constraint to all the vertices.
        intArray ids = new intArray(4);
        ids.setitem(0, 0); ids.setitem(1, 1); ids.setitem(2, 2); ids.setitem(3, 3);
        shapeopCSharp.shapeop_addPlaneConstraint(s, ids.cast(), 4, weight);
        //add a closeness constraint to the 1st vertex.
        shapeopCSharp.shapeop_addClosenessConstraint(s, 0, weight);
        //add a closeness constraint to the 4th vertex.
        shapeopCSharp.shapeop_addClosenessConstraint(s, 3, weight);
        shapeopCSharp.shapeop_init(s);
        shapeopCSharp.shapeop_solve(s, 10);
        shapeopCSharp.shapeop_getPoints(s, p.cast(), 4);
        shapeopCSharp.shapeop_delete(s);
        System.Console.WriteLine("Output points:");
        printArray(p ,4);
    }
    static public void printArray(doubleArray a, int n) {
        for (int c = 0; c < 3; c++) {
            for (int r = 0; r < n; r++)
                Console.Write(a.getitem(r*3 + c) + " ");
            Console.WriteLine();
        }
    }
}
